#!/usr/bin/python

__author__ = 'Jan Goebel <goebel@rz.rwth-aachen.de>'
__version__ = '0.1'

### TODO:
### - extract URLs from PRIVMSG and download files
### - provide thread with download URL
### - perform arbitrary command by thread (PART, PRIVMSG, etc ...)

import sys
import rlcompleter
import readline
import thread
import logging
import os
import re
import psycopg2
import popen2
import random

sys.path.append("core")
import connect_job

class infiltrator_console:
	def __init__(self):
		readline.parse_and_bind("tab: complete")
		readline.set_completer(self.completer)
		readline.set_completer_delims('')

		self.threadlist = {}
		self.nickname = "none"
		self.server = "none"
		self.port = "none"
		self.usermode = "none"
		self.channel = "none"
		self.password = "none"

		self.mode = 'main'
		self.prompt = '>> '
		
		self.dbconn = None
		self.db_cnc_id = None
		self.bot = None
		self.channel_id = None

		self.main_command_list = {}
		### main
		self.main_command_list['?'] = 'show_commands'
		self.main_command_list['quit'] = 'quit'
		self.main_command_list['ping'] = 'ping'
		self.main_command_list['nslookup'] = 'nslookup'
		### show
		self.main_command_list['show version'] = 'show_version'
		self.main_command_list['show threads'] = 'show_threads'
		self.main_command_list['show nickname'] = 'show_nickname'
		self.main_command_list['show server'] = 'show_server'
		self.main_command_list['show port'] = 'show_port'
		self.main_command_list['show usermode'] = 'show_usermode'
		self.main_command_list['show all'] = 'show_all'
		self.main_command_list['show stored'] = 'show_stored'
		self.main_command_list['show configuration'] = 'show_conf'
		### load/save/delete configuration
		self.main_command_list['load configuration'] = 'load_conf'
		self.main_command_list['save configuration'] = 'save_conf'
		self.main_command_list['delete configuration'] = 'del_conf'
		### set
		self.main_command_list['set server'] = 'set_server'
		self.main_command_list['set port'] = 'set_port'
		self.main_command_list['set nickname'] = 'set_nickname'
		self.main_command_list['set usermode'] = 'set_usermode'
		self.main_command_list['set channel'] = 'set_channel'
		self.main_command_list['set talkback'] = 'set_talkback'
		self.main_command_list['set password'] = 'set_password'
		### get
		self.main_command_list['get topics'] = 'get_topics'
		self.main_command_list['get privmsg'] = 'get_privmsg'
		self.main_command_list['get last'] = 'get_last'
		### clear
		self.main_command_list['clear all'] = 'clear_all'
		### start/stop thread
		self.main_command_list['start thread'] = 'start_thread'
		self.main_command_list['stop thread'] = 'stop_thread'
		### join channel
		self.main_command_list['thread join'] = 'thread_join'
		self.main_command_list['thread ping'] = 'thread_ping'
		self.main_command_list['thread read'] = 'thread_read'
		### db
		self.main_command_list['db open'] = 'db_open'
		self.main_command_list['db close'] = 'db_close'
		self.main_command_list['db listcncs'] = 'db_list_cncs'
		self.main_command_list['db loadcnc'] = 'db_load_cnc'
		self.main_command_list['db listconfigurations'] = 'db_list_conf'
		self.main_command_list['db loadconfiguration'] = 'db_load_conf'
		self.main_command_list['db autostart'] = 'db_auto_start'
				
		self.running = True
		print "\nInfiltrator Console v%s\n? - for help\n\n" % (__version__)

	def completer(self, text, state):
		if state==0:
			text = readline.get_line_buffer()
			self.matches = self.get_matches(text)
		try:
			return self.matches[state]
		except IndexError:
			return None

	def get_matches(self, text):
		matches = []
		n = len(text)
		if self.mode=='main':
			for word in self.main_command_list.keys():
				if word[:n] == text:
					matches.append(word+' ')
		return matches

	def show_commands(self, input):
		try:
			input_list = input.split(' ')
			if len(input_list)==1:
				liste = []
				if self.mode == 'main':
					for word in self.main_command_list.keys():
						if word!='?':
							liste.append(word)
					liste.sort()
					for word in liste:
						print "\t%s" % (word)
			elif len(input_list)==2:
				quest = input_list[1]
				if quest=='quit':
					print "\texit the infiltrator console"
				elif quest=='?':
					print "\tshow available commands or show help for given command"
				elif quest=='ping':
					print "\tping a host\n\tping <host>"
				elif quest=='nslookup':
					print "\tlookup DNS for host\n\tnslookup <host>"
				else:
					liste = []
					for word in self.main_command_list.keys():
						if word!='?' and word.startswith(quest):
							liste.append(word)
					liste.sort()
					if len(liste)>0:
						for word in liste:
							print "\t%s" % (word)
					else:
						print "\tno help for command %s" % (quest)
			elif len(input_list)==3:
				### define help for commands
				quest = "%s %s" % (input_list[1], input_list[2])
				if quest=='get last':
					print "\tget the last 50 lines from a running thread\n\tget last <thread>"
				elif quest=='get privmsg':
					print "\tget all private message received by a running thread\n\tget privmsg <thread>"
				elif quest=='get topics':
					print "\tget all topics received by a running thread\n\tget topics <thread>"
				elif quest=='load configuration':
					print "\tload a botnet configuration from file\n\tload configuration <filename>"
				elif quest=='save configuration':
					print "\tsave a botnet configuration to file.\n\ttakes next free filename or a name supplied\n\tsave configuration [filename]"
				elif quest=='show all':
					print "\tshow currently loaded botnet configuration"
				elif quest=='clear all':
					print "\tclears the irc parameters"
				elif quest=='set channel':
					print "\tset channel to join\n\tset channel <channel> [password]"
				elif quest=='set nickname':
					print "\tset nickname to use\n\tset nickname <nickname>"
				elif quest=='set server':
					print "\tset IRC server to connect to\n\tset server <ip adress>"
				elif quest=='set port':
					print "\tset IRC port\n\tset port <port>"
				elif quest=='set usermode':
					print "\tset the usermode for given nickname\n\tset usermode <mode>"
				elif quest=='set password':
					print "\tset irc server password"
				elif quest=='thread join':
					print "\torder thread to join another channel\n\tthread join <thread> <channel> [passwort]"
				elif quest=='thread ping':
					print "\torder thread to ping IRC server\n\tthread ping <thread>"
				elif quest=='thread read':
					print "\tconnect to output pipe of thread and read all traffic\n\tthread read <thread>"
				else:
					print "\tno help for command %s" % (quest)
			else:
				print "\twrong parameters supplied"
		except StandardError,e:
			print "\t%s" % (e)

	def show_version(self):
		print "\tInfiltrator Console v%s" % (__version__)

	def check_input(self, input):
		try:
			input_list = input.split(' ')
			if len(input_list)>=3 and input_list[0]!='?':
				input = '%s %s' % (input_list[0],input_list[1])
			elif len(input_list)>=2 and input_list[0]=='?':
				input = input_list[0]
			elif len(input_list)>=2 and (input_list[0]=='ping' or input_list[0]=='nslookup'):
				input = input_list[0]
			if self.mode=='main':
				try:
					function = self.main_command_list[input]
				except KeyError:
					input = self.get_closest_match(input)
					function = self.main_command_list[input]
			return function
		except KeyError:
			print "\tCommand not found."
			return 'none'

	def get_closest_match(self, input):
		input_list = input.split(' ')
		keys = self.main_command_list.keys()
		for key in keys:
			key_list = key.split(' ')
			if key_list[0].startswith(input_list[0]):
				if len(input_list)>1:
					if key_list[1].startswith(input_list[1]):
						return key
				else:
					return key
		return 'none'
			

	def show_threads(self):
		keys = self.threadlist.keys()
		if len(keys)>0:
			for key in keys:
				print "\t%s" % (self.threadlist[key].getName())
		else:
			print "\tno threads running"

	def clearAll(self):
		self.nickname = "none"
		self.server = "none"
		self.port = "none"
		self.usermode = "none"
		self.channel = "none"
		self.password = "none"

	def show_all(self):
		print "\tnickname: %s" % (self.nickname)
		print "\tserver: %s" % (self.server)
		print "\tport: %s" % (self.port)
		print "\tuser: %s" % (self.usermode)
		print "\tchannel: %s" % (self.channel)
		print "\tpassword: %s" % (self.password)

	def run_command(self, call, input):
		if call=='show_version':
			self.show_version()
		elif call=='quit':
			self.running = False
		elif call=='show_commands':
			self.show_commands(input)
		elif call=='show_threads':
			self.show_threads()
		elif call=='show_nickname':
			print "\tnickname: %s" % (self.nickname)
		elif call=='show_server':
			print "\tserver: %s" % (self.server)
		elif call=='show_port':
			print "\tport: %s" % (self.port)
		elif call=='show_usermode':
			print "\tuser: %s" % (self.usermode)
		elif call=='show_all':
			self.show_all()
		elif call=='show_stored':
			self.list_stored()
		elif call=='show_conf':
			self.show_configuration(input)
		elif call=='set_nickname':
			self.nickname = self.set_irc(input, "nickname")
		elif call=='set_server':
			self.server = self.set_irc(input, "server")
		elif call=='set_port':
			self.port = self.set_irc(input, "port")
			if int(self.port)<=0 or int(self.port)>65530:
				print "\tinvalid port (%s)" % (self.port)
				self.port = "none"
		elif call=='set_usermode':
			self.usermode = self.set_irc(input, "usermode")
		elif call=='set_channel':
			self.channel = self.set_irc(input, "channel")
		elif call=='set_password':
			self.password = self.set_irc(input, "password")
		elif call=='set_talkback':
			self.toggle_talkback(input)
		elif call=='load_conf':
			self.load_configuration(input)
		elif call=='save_conf':
			self.save_configuration(input)
		elif call=='del_conf':
			self.del_configuration(input)
		elif call=='db_open':
			self.db_open(input)
		elif call=='db_load_cnc':
			self.db_load_cnc(input)
		elif call=='db_list_cncs':
			self.db_list_cncs(input)
		elif call=='db_list_conf':
			self.db_list_configurations(input)
		elif call=='db_load_conf':
			self.db_load_configuration(input)
		elif call=='db_auto_start':
			self.db_auto_start(input)
		elif call=='start_thread':
			self.runthread()
		elif call=='stop_thread':
			self.stopthread(input)
		elif call=='thread_join':
			self.threadjoin(input)
		elif call=='thread_ping':
			self.threadping(input)
		elif call=='thread_read':
			self.threadread(input)
		elif call=='get_topics':
			self.getTopics(input)
		elif call=='get_privmsg':
			self.getMsg(input)
		elif call=='get_last':
			self.getLast(input)
		elif call=='ping':
			self.ping_host(input)
		elif call=='nslookup':
			self.lookup(input)
		elif call=='clear_all':
			self.clearAll()

	def lookup(self, input):
		input_list = input.split(' ')
		if len(input_list)==2:
			command = "nslookup %s" % (input_list[1])
		else:
			if self.server!='none':
				command = "nslookup %s" % (self.server)
			else:
				print "\tno host to lookup"
				return
		try:
			print "\t%s" % (command)
			child = popen2.Popen4(command)
			line = child.fromchild.readline()
			while line:
				line = str(line).strip()
				print "\t%s" % (line)
				line = child.fromchild.readline()
			child.wait()
		except StandardError, e:
			print "\t%s" % (e)
		except KeyboardInterrupt:
			print "\tdone"

	def ping_host(self, input):
		input_list = input.split(' ')
		if len(input_list)==2:
			command = "ping %s" % (input_list[1])
		else:
			if self.server!='none':
				command = "ping %s" % (self.server)
			else:
				print "\tno host to ping"
				return
		try:
			print "\t%s" % (command)
			child = popen2.Popen4(command)
			line = child.fromchild.readline()
			while line:
				line = str(line).strip()
				print "\t%s" % (line)
				line = child.fromchild.readline()
			child.wait()
		except StandardError, e:
			print "\t%s" % (e)
		except KeyboardInterrupt:
			print "\tdone"

	def del_configuration(self, input):
		input_list = input.split(' ')
		if len(input_list)==3:
			try:
				filename = "conf/%s.net" % (input_list[2])
				os.remove(filename)
				print "\tbotnet configuration %s.net removed" % (input_list[2])
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tno configuration file supplied"

	def show_configuration(self, input):
		input_list = input.split(' ')
		if len(input_list)==3:
			try:
				filename = "conf/%s.net" % (input_list[2])
				if os.path.exists(filename):
					fp = open(filename, 'r')
					content = "".join(fp.readlines())
					fp.close()
					n_expr = re.compile('nickname: (.*)')
					s_expr = re.compile('server: (.*)')
					p_expr = re.compile('port: (.*)')
					u_expr = re.compile('usermode: (.*)')
					c_expr = re.compile('channel: (.*)')
					w_expr = re.compile('password: (.*)')
					match = n_expr.search(content)
					if match:
						print "\tnickname: %s" % (match.groups()[0])
					match = s_expr.search(content)
					if match:
						print "\tserver: %s" % (match.groups()[0])
					match = p_expr.search(content)
					if match:
						print "\tport: %s" % (match.groups()[0])
					match = u_expr.search(content)
					if match:
						print "\tuser: %s" % (match.groups()[0])
					match = c_expr.search(content)
					if match:
						print "\tchannel: %s" % (match.groups()[0])
					match = w_expr.search(content)
					if match:
						print "\tpassword: %s" % (match.groups()[0])
				else:
					print "\tno such configuration file: %s " % (filename)
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tno configuration file supplied"
	
	def db_open(self, input):
		self.dbconn = psycopg2.connect (host='localhost', port='5432', database='malware', user='malware_user', password='malware_password')
		if self.dbconn != None:
			print "\tconnection successful"
		else:
			print "\tconnection failed"
	
	def db_close(self, input):
		if self.dbconn != None:
			self.dbconn.close()
	
	def db_list_cncs(self, input):
		cur = self.dbconn.cursor()
		cur.execute("SELECT id, address, port FROM cncs WHERE type='irc'")
		print cur.rowcount
		row = cur.fetchone()
		print row
		while row != None:
			print "\tid: %s" %(row[0])
			print "\taddress: %s" %(row[1])
			print "\tport: %s" %(row[2])
			cur2 = self.dbconn.cursor()
			cur2.execute('SELECT * FROM irc_bots WHERE cnc=%s', [ row[0] ])
			print "\tconfigurations: %s" %(cur2.rowcount)
			cur2.close()
			print
			row = cur.fetchone()
		cur.close()
	
	def db_load_cnc(self, input):
		input_list = input.split(' ')
		cnc_id = int(input_list[2])
		randomconf = False
		if len(input_list) == 4:
			if input_list[3] == 'random':
				randomconf = True
		cur = self.dbconn.cursor()
		cur.execute('SELECT id, address, port FROM cncs WHERE id=%s', [ cnc_id ])
		res = cur.fetchone()
		self.db_cnc_id = res[0]
		self.server = res[1]
		self.port = res[2]
		print "\tloaded cnc"
		cur.execute('SELECT id FROM irc_bots WHERE cnc=%s', [ self.db_cnc_id ])
		if cur.rowcount == 1:
			res = cur.fetchone()
			self.db_load_configuration("db loadconfiguration %s" %(res[0]))
		elif randomconf:
			res = cur.fetchall()
			self.db_load_configuration("db loadconfiguration %s" %(random.sample(res,1)[0]))
		cur.close()
		
	
	def db_list_configurations(self, input):
		input_list = input.split(' ')
		if len(input_list) == 3:
			cnc_id = int(input_list[2])
		else:
			cnc_id = self.db_cnc_id
		cur = self.dbconn.cursor()
		cur.execute('SELECT id, password, nickname, username, hostname, servername, realname from irc_bots WHERE cnc = %s', [ cnc_id ])
		row = cur.fetchone()
		while row != None:
			print "\tid: %s" %(row[0])
			if row[1] != None:
				print "\tserver password: %s" %(row[1])
			print "\tnickname: %s" %(row[2])
			print "\tusermode: %s %s %s %s" %(row[3],row[4],row[5],row[6])
			cur2 = self.dbconn.cursor()
			cur2.execute('SELECT name, password from irc_channels, irc_bots_refc WHERE id = irc_channel AND irc_bot = %s', [ row[0] ])
			if cur2.rowcount > 0:
				chan = cur2.fetchone()
				print "\tchannel: %s" %(chan[0])
				if chan[1] != None:
					print "\tchannel password: %s" %(chan[1])
			cur2.close()
			print
			row = cur.fetchone()
		cur.close()
			
	def db_load_configuration(self, input):
		input_list = input.split(' ')
		cnc_id = self.db_cnc_id
		conf_id = int(input_list[2])
		cur = self.dbconn.cursor()
		self.bot = conf_id
		cur.execute('SELECT nickname, password, username, hostname, servername, realname from irc_bots WHERE cnc = %s AND id = %s', [ cnc_id, conf_id ])
		conf = cur.fetchone()
		self.nickname = conf[0]
		if conf[1] != None:
			self.password = conf[1]
		self.usermode = "%s %s %s %s" %(conf[2],conf[3],conf[4],conf[5])
		cur.execute('SELECT id, name, password from irc_channels, irc_bots_refc WHERE id = irc_channel AND irc_bot = %s', [ conf_id ])
		if cur.rowcount > 0:
			chan = cur.fetchone()
			if chan[2] != None:
				self.channel = "%s %s" %(chan[1], chan[2])
			else:
				self.channel = chan[1]
			self.channel_id = chan[0]
		print "\tconfiguration loaded\n"
		cur.close()
		self.show_all()	

	def db_auto_start(self, input):
		input_list = input.split(' ')
		cur = self.dbconn.cursor()
		if len(input_list)==3:
			cur.execute("SELECT id FROM cncs WHERE type='irc' AND active = true")
		else:
			cur.execute("SELECT id FROM cncs WHERE type='irc'")
		row = cur.fetchone()
		while row != None:
			self.db_load_cnc("db loadcnc %s random" %(row[0]))
			print "\tstarting thread for cnc %s" %(row[0])
			self.runthread()
			row = cur.fetchone()
		cur.close()
			
	def load_configuration(self, input):
		input_list = input.split(' ')
		if len(input_list)==3:
			try:
				filename = "conf/%s.net" % (input_list[2])
				if os.path.exists(filename):
					fp = open(filename, 'r')
					content = "".join(fp.readlines())
					fp.close()
					n_expr = re.compile('nickname: (.*)')
					s_expr = re.compile('server: (.*)')
					p_expr = re.compile('port: (.*)')
					u_expr = re.compile('usermode: (.*)')
					c_expr = re.compile('channel: (.*)')
					w_expr = re.compile('password: (.*)')
					match = n_expr.search(content)
					if match:
						self.nickname = match.groups()[0]
					match = s_expr.search(content)
					if match:
						self.server = match.groups()[0]
					match = p_expr.search(content)
					if match:
						self.port = match.groups()[0]
					match = u_expr.search(content)
					if match:
						self.usermode = match.groups()[0]
					match = c_expr.search(content)
					if match:
						self.channel = match.groups()[0]
					match = w_expr.search(content)
					if match:
						self.password = match.groups()[0]
					print "\tconfiguration loaded"
					self.show_all()
				else:
					print "\tno such configuration file: %s" % (filename)
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tno configuration file supplied"

	def save_configuration(self, input):
		init = 0
		input_list = input.split(' ')
                if len(input_list)==2:
			try:
				while True:
					init += 1
					filename = "conf/bot%i.net" % (init)
					if not os.path.exists(filename):
						fp = open(filename, 'w')
						fp.write("nickname: %s\n" % (self.nickname))
						fp.write("server: %s\n" % (self.server))
						fp.write("port: %s\n" % (self.port))
						fp.write("usermode: %s\n" % (self.usermode))
						fp.write("channel: %s\n" % (self.channel))
						fp.write("password: %s\n" % (self.password))
						fp.close()
						break
				print "\twrote %s configuration file" % (filename)
			except StandardError, e:
				print "\t%s" % (e)
		elif len(input_list)==3:
			try:
				filename = "conf/%s.net" % (input_list[2])
				if os.path.exists(filename):
					print "\toverwriting existing configuration file"
				fp = open(filename, 'w')
				fp.write("nickname: %s\n" % (self.nickname))
				fp.write("server: %s\n" % (self.server))
				fp.write("port: %s\n" % (self.port))
				fp.write("usermode: %s\n" % (self.usermode))
				fp.write("channel: %s\n" % (self.channel))
				fp.write("password: %s\n" % (self.password))
				fp.close()
				print "\twrote %s configuration file" % (filename)
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\twrong parameters supplied"

	def list_stored(self):
		liste = []
		try:
			entries = os.listdir('conf/')
			for item in entries:
				if item.endswith('.net'):
					liste.append(item)
			liste.sort()
			for item in liste:
				print "\t%s" % (item)
		except StandardError, e:
			print "\t%s" % (e)

	def getTopics(self, input):
		found = False
		input_list = input.split(' ')
		if len(input_list)==3:
			try:
				thread_name = input_list[2]
				keys = self.threadlist.keys()
				if len(keys)>0:
					for key in keys:
						if self.threadlist[key].getName() == thread_name:
							topic_list = self.threadlist[key].get_topics()
							found = True
							break
				if found:
					for entry in reversed(topic_list):
						print "\t%s" % (entry)
				else:
					print "\tno topics collected"
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tthread incorrect/missing"

	def getMsg(self, input):
		found = False
		input_list = input.split(' ')
		if len(input_list)==3:
			try:
				thread_name = input_list[2]
				keys = self.threadlist.keys()
				if len(keys)>0:
					for key in keys:
						if self.threadlist[key].getName() == thread_name:
							msg_list = self.threadlist[key].get_privmsg()
							found = True
							break
				if found:
					for entry in reversed(msg_list.keys()):
						print "\t%s" % (entry)
				else:
					print "\tno private messages received"
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tthread incorrect/missing"

	def toggle_talkback(self, input):
		input_list = input.split(' ')
		if len(input_list)==3:
			try:
				thread_name = input_list[2]
				keys = self.threadlist.keys()
				if len(keys)>0:
					for key in keys:
						if self.threadlist[key].getName() == thread_name:
							mode = self.threadlist[key].toggle_talkback()
							break
					print "\tTalkback: %s" % (mode)
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tthread incorrect/missing"

	def getLast(self, input):
		found = False
		input_list = input.split(' ')
		if len(input_list)==3:
			try:
				thread_name = input_list[2]
				keys = self.threadlist.keys()
				if len(keys)>0:
					for key in keys:
						if self.threadlist[key].getName() == thread_name:
							last_list = self.threadlist[key].get_last()
							found = True
							break
				if found:
					for entry in last_list:
						print "\t%s" % (entry)
				if not found:
					print "\tno thread found"
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tthread incorrect/missing"

	def threadping(self, input):
		input_list = input.split(' ')
		if len(input_list)==3:
			try:
				thread_name = input_list[2]
				keys = self.threadlist.keys()
				if len(keys)>0:
					for key in keys:
						if self.threadlist[key].getName() == thread_name:
							self.threadlist[key].ping_host()
							print "\tping send"
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tthread incorrect/missing"

	def threadread(self, input):
		input_list = input.split(' ')
		if len(input_list)==3:
			try:
				thread_name = input_list[2]
				keys = self.threadlist.keys()
				if len(keys)>0:
					for key in keys:
						if self.threadlist[key].getName() == thread_name:
							self.threadlist[key].read()
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tthread incorrect/missing"

	def threadjoin(self, input):
		input_list = input.split(' ')
		if len(input_list)>=4:
			thread_name = input_list[2]
			channel_name = " ".join(input_list[3:])
			try:
				keys = self.threadlist.keys()
				if len(keys)>0:
					for key in keys:
						if self.threadlist[key].getName() == thread_name:
							self.threadlist[key].join_chan(channel_name)
							print "\t%s joining channel %s" % (thread_name, channel_name)
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tthread/channel incorrect/missing"


	def stopthread(self, input):
		input_list = input.split(' ')
		if len(input_list)==3:
			thread_name = input_list[2]
			try:
				keys = self.threadlist.keys()
				if len(keys)>0:
					for key in keys:
						if self.threadlist[key].getName() == thread_name:
							self.threadlist[key].stop()
							self.threadlist[key].join(10.0)
							del self.threadlist[key]
							print "\tstopped %s" % (thread_name)
			except StandardError, e:
				print "\t%s" % (e)
		else:
			print "\tno thread supplied"

	def runthread(self):
		try:
			if self.server!='none' and self.port!='none' and self.nickname!='none':
				extension = 0
				if self.db_cnc_id != None:
					tname = "irc%i" % (self.db_cnc_id)
				else:
					tname = "irc%i" % (extension)
					while tname in self.threadlist.keys():
						extension += 1
						tname = "irc%i" % (extension)
				t = None
				t = connect_job.connect_job(self.dbconn, self.bot, tname, self.server, self.port, self.nickname, self.usermode, self.channel, self.channel_id, self.password)
				t.setName(tname)
				self.threadlist[tname] = t
				t.start()
				print "\tthread started"
			else:
				print "\tinsufficient parameters (server/port/nickname not set)"
		except StandardError, e:
			print "\t%s" % (e)


	def set_irc(self, input, value):
		input_list = input.split(' ')
		if len(input_list)>=3:
			variable = " ".join(input_list[2:])
			print "\tsetting %s: %s" % (value, variable)
			return variable
		else:
			variable = raw_input("\tenter %s: " % (value))
			return variable

	def infiltrator(self):
		while self.running:
			### wait for input
			try:
				input = raw_input(self.prompt).strip()
				if len(input)>0:
					call = self.check_input(input)
					self.run_command(call, input)
			except:
				print
		keys = self.threadlist.keys()
		for key in keys:
			self.threadlist[key].stop()
			self.threadlist[key].join(10.0)
			del self.threadlist[key]
		return



if __name__=='__main__':
	inf_obj = infiltrator_console()
	inf_obj.infiltrator()
