#!/usr/bin/python
import psycopg2
import xml.dom.minidom
from xml.dom.minidom import Node
import urllib2
import sys
import re

ALLAPLE_MUTEX_NAME = 'jhdheddfffffhjk5trh'
ALLAPLE_FILE_NAME = 'urdvxc.exe'
ALLAPLE_ID = 1

def getAttribute(attributes, key):
    if attributes.has_key(key):
        return attributes[key].value
    else:
        return None

def getText(node):
    val = ''
    for node3 in node.childNodes:
        if node3.nodeType == Node.TEXT_NODE:
            val += node3.data
    return val

def process_virustotal(cur, report):
	# SQL prepared queries
    set_processed = 'UPDATE reports SET processed = true WHERE md5 = %s and provider::text = %s'
    add_av_report = 'INSERT INTO av_reports (md5, scanner, scanner_version, signature_version, classification) VALUES (%s, %s, %s, %s, %s)'
    process_av_report = 'SELECT process_av_report(%s)'
    
    allaple_count = 0
    root_n = xml.dom.minidom.parseString(report)
    analysis_n = root_n.getElementsByTagName('analysis')[0]
    md5 = getAttribute(analysis_n.attributes, 'md5')
    virusscan_n = analysis_n.getElementsByTagName('virusscan_section')[0]
    for scanner_n in virusscan_n.getElementsByTagName('scanner'):
        scanner = getAttribute(scanner_n.attributes, 'name')
        scanner_version = getAttribute(scanner_n.attributes, 'application_version')
        signature_version = getAttribute(scanner_n.attributes, 'signature_file_version')
        classification = getText(scanner_n.getElementsByTagName('classification')[0])
        cur.execute(add_av_report, [ md5, scanner, scanner_version, signature_version, classification ])
    cur.execute(set_processed, [ md5, 'VirusTotal' ])
    cur.execute(process_av_report, [ md5 ])
    return True

def process_cwsandbox(cur, report):
	# SQL prepared queries
    add_cnc = 'SELECT add_cnc(%s, %s, %s, %s)'
    add_http_bot = 'SELECT add_http_bot(%s, %s)'
    add_http_cmd = 'SELECT add_http_cmd(%s, %s, %s, %s, %s)'
    add_irc_bot = 'SELECT add_irc_bot(%s, %s, %s, %s, %s, %s, %s, %s, %s)'
    add_irc_channel = 'SELECT add_irc_channel(%s, %s, %s, %s)'
    add_irc_privmsg = 'SELECT add_irc_privmsg(%s, %s, %s)'
    add_target = 'SELECT add_target(%s, %s, %s, %s, %s, %s, %s)'
    set_sample = 'SELECT set_sample(%s, %s, %s)'
    set_processed = 'UPDATE reports SET processed = true WHERE md5 = %s and provider::text = %s'

    dnsqueries = []
    revdnsqueries = []
    allaple_mutex = False
    allaple_file = False
    winfile_r = re.compile('^.*\\\\(.*)$')
    root_n = xml.dom.minidom.parseString(report)
    analysis_n = root_n.getElementsByTagName("analysis")[0]
    md5 = getAttribute(analysis_n.attributes, 'md5')
    analysis_date = getAttribute(analysis_n.attributes, 'time')
    date_r = re.compile('^([0-9]+)/([0-9]+)/([0-9]+)\ (.*)$')
    date_m = date_r.search(analysis_date)
    if date_m != None:
        month = date_m.group(1)
        day = date_m.group(2)
        year = date_m.group(3)
        time = date_m.group(4)
        analysis_date = "%s.%s.%s %s" %(day, month, year, time)
        print "braindead date format, workaround activated; fixed date is '%s'" %(analysis_date)
    processes_n = analysis_n.getElementsByTagName("processes")[0]
    targets = []
    malwares = []
    for process_n in processes_n.getElementsByTagName("process"):
        ## FILESYSTEM ##
        filesys_n = process_n.getElementsByTagName("filesystem_section")
        if len(filesys_n) > 0:
            copy_n = filesys_n[0].getElementsByTagName("copy_file")
            for copy_op in copy_n:
                dest = copy_op.attributes['dstfile'].value
                m = winfile_r.search(dest)
                if m != None:
                    name = m.group(1)
                    if name == ALLAPLE_FILE_NAME:
                        allaple_file = True
        ## MUTEX ##
        mutex_n = process_n.getElementsByTagName("mutex_section")
        if len(mutex_n) > 0:
            create_mutex_n = mutex_n[0].getElementsByTagName("create_mutex")
            for mutex in create_mutex_n:
                name = getAttribute(mutex.attributes,'name')
                if name == ALLAPLE_MUTEX_NAME:
                    allaple_mutex = True 
        if allaple_file and allaple_mutex:
            cur.execute(set_sample, [ md5, 'worm', ALLAPLE_ID ])
            cur.execute(set_processed, [ md5, 'CWSandbox' ])
            return True
        ## WINSOCK ##
        winsock_n = process_n.getElementsByTagName("winsock_section")
        if len(winsock_n) > 0:
            conns_unk_n = winsock_n[0].getElementsByTagName("connections_unknown")
            if len(conns_unk_n) > 0:
                conn_unk_n = conns_unk_n[0]
                for conn_n in conn_unk_n.getElementsByTagName("connection"):
                    for gethostbyname_n in conn_n.getElementsByTagName("gethostbyname"):
                        gethostbyname_a = gethostbyname_n.attributes
                        host = getAttribute(gethostbyname_a, 'requested_host')
                        address = [ getAttribute(gethostbyname_a, 'resulting_addr') ]
                        more_n = gethostbyname_n.getElementsByTagName("more_resulting_addr")
                        if len(more_n) > 0:
                            for node in more_n[0].getElementsByTagName("resulting_addr"):
                                t = getText(node)
                                if t != '':
                                    address.append(t)
                        dnsqueries.append([host, address])
                    for gethostbyaddr_n in conn_n.getElementsByTagName("gethostbyaddr"):
                        gethostbyaddr_a = gethostbyaddr_n.attributes
                        address = getAttribute(gethostbyaddr_a, 'requested_addr')
                        host = getAttribute(gethostbyaddr_a, 'resulting_host')
                        revdnsqueries.append([address, host])
                
            conns_out_n = winsock_n[0].getElementsByTagName("connections_outgoing")
            if len(conns_out_n) > 0:
                conn_out_n = conns_out_n[0]
                for conn_n in conn_out_n.getElementsByTagName("connection"):
                    transport = conn_n.attributes['transportprotocol'].value
                    remote_addr = conn_n.attributes['remoteaddr'].value
                    remote_port = int(conn_n.attributes['remoteport'].value)
                    remote_dns = ''
                    if conn_n.attributes['connectionestablished'].value == '0':
                        established = False
                    else:
                        established = True
                    for query in dnsqueries:
                        host = query[0]
                        for address in query[1]:
                            if remote_addr == address:
                                remote_dns = host
                                break
                        if remote_dns != '':
                            break
                    if conn_n.attributes.has_key('protocol'):
                         protocol = conn_n.attributes['protocol'].value
                         if protocol == 'IRC':
                             cnc = [ remote_addr, remote_port, 'irc', remote_dns ]
                             
                             ircdata_n = conn_n.getElementsByTagName("irc_data")[0]
                             ircdata_a = ircdata_n.attributes
                             hostname = getAttribute(ircdata_a, 'hostname')
                             servername = getAttribute(ircdata_a, 'servername')
                             username = getAttribute(ircdata_a, 'username')
                             realname = getAttribute(ircdata_a, 'realname')
                             #FIXME workaround for CWsandbox parsing bug
                             if realname == '-Service':
                                 realname = '-Service Pack 2'
                             password = getAttribute(ircdata_a, 'password')
                             nickname = getAttribute(ircdata_a, 'nick')
                             if getAttribute(ircdata_a, 'non_rfc_conform') == '0':
                                 rfc_compliant = 'true'
                             else:
                                 rfc_compliant = 'false'
                             bot_data = [hostname, realname, nickname, username, password, servername, rfc_compliant, analysis_date]
                             channels = []
                             for channel_n in ircdata_n.getElementsByTagName("channel"):
                                 channel_a = channel_n.attributes
                                 chan_name = getAttribute(channel_a, 'name')
                                 chan_password = getAttribute(channel_a, 'password')
                                 chan_topic = getAttribute(channel_a, 'topic_deleted')
                                 channels.append([chan_name, chan_password, chan_topic])
                             notices = []
                             for notice_n in ircdata_n.getElementsByTagName("notice_deleted"):
                                 notice_value = getAttribute(notice_n.attributes, 'value')
                                 notices.append(['n', notice_value])
                             for priv_n in ircdata_n.getElementsByTagName("privmsg_deleted"):
                                 priv_value = getAttribute(priv_n.attributes, 'value')
                                 notices.append(['p', priv_value])
                             malwares.append([ 'irc', cnc, bot_data, channels, notices ])
                         elif protocol == 'HTTP':
                             cnc = [ remote_addr, remote_port, 'http', remote_dns ]
                             bot_data = [ analysis_date ]
                             httpcmds = []
                             httpdata_n = conn_n.getElementsByTagName("http_data")[0]
                             for httpcmd_n in httpdata_n.getElementsByTagName('http_cmd'):
                                 httpcmd_a = httpcmd_n.attributes
                                 url = getAttribute(httpcmd_a, 'url')
                                 method = getAttribute(httpcmd_a, 'method')
                                 http_version = getAttribute(httpcmd_a, 'http_version')
                                 headers = []
                                 headers_n = httpcmd_n.getElementsByTagName('header_data')
                                 if len(headers_n) > 0:
                                     for header_n in headers_n[0].getElementsByTagName('header'):
                                         t = getText(header_n)
                                         if t != '':
                                             headers.append(t)
                                 headers_s = '\n'.join(headers)
                                 httpcmds.append([url, method, http_version, headers_s])
                             malwares.append(['http', cnc, bot_data, httpcmds ])
                         else:
                             targets.append([ remote_addr, remote_port, transport, analysis_date, remote_dns, established ])
                    else:
                        targets.append([ remote_addr, remote_port, transport, analysis_date, remote_dns, established ])
        ## ICMP ##
        icmp_n = process_n.getElementsByTagName("icmp_section")
        if len(icmp_n) > 0:
            for ping_n in icmp_n[0].getElementsByTagName("ping"):
                ping_a = ping_n.attributes
                host = getAttribute(ping_a, 'host')
                remote_dns = ''
                for query in dnsqueries:
                    host = query[0]
                    for address in query[1]:
                        if remote_addr == address:
                            remote_dns = host
                            break
                    if remote_dns != '':
                        break
                targets.append([ host, None, 'ICMP', analysis_date, remote_dns, None ])
    bot_id = None
    for malware in malwares:
        cur.execute(add_cnc, malware[1])
        cnc_id = cur.fetchone()[0]
        type = malware[0]
        bot_data = malware[2]
        bot_data.insert(0, cnc_id)
        if type == 'irc':
            cur.execute(add_irc_bot, bot_data)
            bot_id = cur.fetchone()[0]
            if len(malware[3]) > 0:
                channels = malware[3][0]
                channels.insert(0, bot_id)
                cur.execute(add_irc_channel, channels)
            if len(malware[4]) > 0:
                notices = malware[4][0]
                notices.insert(0, bot_id)
                cur.execute(add_irc_privmsg, notices)
            cur.execute(set_sample, [ md5, 'irc_bot', bot_id ])
        elif type == 'http':
            cur.execute(add_http_bot, bot_data)
            bot_id = cur.fetchone()[0]
            if len(malware[3]) > 0:
                httpcmds = malware[3][0]          
                httpcmds.insert(0, bot_id)
                cur.execute(add_http_cmd, httpcmds)
            cur.execute(set_sample, [ md5, 'http_bot', bot_id ])
        else:
            print "unknown malware '%s'" %(type)
    if bot_id != None:
        for target in targets:
            target.insert(3, bot_id)
            cur.execute(add_target, target)
        cur.execute(set_processed, [ md5, 'CWSandbox' ])
    return True

def process_report(db, report_id):
	select = 'SELECT md5, provider, task_id, analysis_id, password, processed, XMLSERIALIZE(DOCUMENT report AS text) FROM reports WHERE id = %s'
	selrep = 'SELECT XMLSERIALIZE(DOCUMENT report AS text) FROM reports WHERE id = %s'
	update = 'UPDATE reports SET report = XMLPARSE(DOCUMENT %s), pcap = %s WHERE id = %s'
	cur = db.cursor()
	cur.execute(select, [ report_id ])
	res = cur.fetchone()
	if res[5] == True:
		# already processed
		print "Report %s has already been processed"
		return False
	md5 = res[0]
	provider = res[1]
	xml = res[6]
	if xml == None:
		print "Fetching %s report %s" %(provider, report_id)
		analysis_id = res[3]
		password = res[4]
		xml_url = "http://www.cwsandbox.org/?page=analysis&id=%s&format=xml&password=%s" %(analysis_id, password)
		pcap_url = "http://www.cwsandbox.org/?page=download&dltype=pcap&id=%s&password=%s" %(analysis_id,password)
		http_handler = urllib2.HTTPHandler()
		opener = urllib2.build_opener(http_handler)
		# U = convert newlines
		fd = opener.open(xml_url, 'rU')
		xml = fd.read()
		fd.close()
		fd = opener.open(pcap_url, 'rb')
		pcap = fd.read()
		fd.close()
		# pcap is a binary format, we must escape it
		cur.execute(update, [ xml, psycopg2.Binary(pcap), report_id ])
		db.commit()
		# we fetch from the db the serialized doc to avoid parsing errors
		cur.execute(selrep, [ report_id ])
		xml = cur.fetchone()[0]
	if provider == 'CWSandbox':
		print "Processing %s report %s" %(provider, report_id)
		val = process_cwsandbox(cur, xml)
		return val
	elif provider == 'VirusTotal':
		print "Processing %s report %s" %(provider, report_id)
		val = process_virustotal(cur, xml)
		return val

def process_available_reports(db):
	query = "SELECT id FROM reports WHERE available = true AND processed = false AND (provider = 'CWSandbox' or provider = 'VirusTotal') ORDER BY id DESC LIMIT 100"
	cur = db.cursor()
	cur.execute(query)
	count = 0
	row = cur.fetchone()
	while row != None:
		if process_report(db, row[0]):
			db.commit()
			count = count + 1
		row = cur.fetchone()
	cur.close()
	return count
		
if __name__ == '__main__':
	db = psycopg2.connect (host='localhost', port='5432', database='malware', user='malware_user', password='malware_password')
	cur = db.cursor()
	if len(sys.argv) != 2:
		count = process_available_reports(db)
		print "Processed %i reports" %(count)
	else:
		report_id = sys.argv[1]
		process_report(db, report_id)
	db.commit()
	cur.close()
	db.close()
	
