<?php
	$db = NULL;
	function db_open() {
		global $db;
		$db = pg_connect("host='localhost' port='5432' dbname='malware' user='malware' password='malware'");
	}

	function db_close() {
		global $db;
		pg_close($db);
		$db = NULL;
	}

	// db_query($query, [$param...])
	function db_query($query) {
		global $db;
		$args = func_get_args();
		if(count($args) > 1) {
			array_shift($args); // remove $query from args
			return pg_query_params($db, $query, $args);
		} else {
			return pg_query($db, $query);
		}
	}

	function db_begin() {
		db_query('BEGIN');
	}

	function db_commit() {
		db_query('COMMIT');
	}

	function db_rollback() {
		db_query('ROLLBACK');
	}

	if($_POST['MAX_FILE_SIZE']!='10000000'){
?>
<form enctype="multipart/form-data" action="/upload.php" method="POST">
    <input type="hidden" name="MAX_FILE_SIZE" value="10000000" />
    Send this file: <input name="userfile" type="file" /><br />
    Checksum: <input name="md5" type="text" /><br />
    Sensor: <input name="sensor" type="text" /><br />
    Experiment: <input name="experiment" type="text" /><br />
    File name: <input name="filename" type="text" /><br />
    File path: <input name="filepath" type="text" /><br />
    File date: <input name="filedate" type="text" /><br />
    File size: <input name="filesize" type="text" /><br />
    <input type="submit" value="Send File" />
</form>
<?php
	} else {
		$uploaddir = '/var/www/uploads/';
		$md5_client = $_POST['md5'];
		$uploadfile = $uploaddir . $md5_client;
		$sensor = $_POST['sensor'];
		$experiment = $_POST['experiment'];
		$filename = $_POST['filename'];
		$filepath = $_POST['filepath'];
		$filedate = $_POST['filedate'];
		$filesize = $_POST['filesize'];

		db_open();
		db_begin();

		if(pg_num_rows(db_query('SELECT md5 FROM samples WHERE md5 = $1', $md5_client)) == 0) {
			// new sample, ack upload and register
			if(move_uploaded_file($_FILES['userfile']['tmp_name'], $uploadfile)) {
				chmod($uploadfile, 0660);
				$md5 = md5_file($uploadfile);
				if($md5_client == $md5) {
					echo "File is valid, and was successfully uploaded.<br />";
					db_query('INSERT INTO samples (md5, size) VALUES ($1, $2)', 
						$md5, $filesize);
				} else {
					echo "MD5 mismatch, file is probably corrupt, aborting.<br />";
					unlink($uploadfile);
					db_rollback();
				}
			} else {
				echo "Upload failed, aborting";
				db_rollback();
			}
		}
		
		if(pg_num_rows(db_query('SELECT name FROM sensors WHERE name=$1', $sensor)) == 0) {
			echo "Invalid sensor, aborting.<br />";
			db_rollback();
		} else {
			db_query(
			'INSERT INTO sightings (md5, sensor, experiment, filename, filepath, filedate) VALUES ($1, $2, $3, $4, $5, $6)',
			$md5_client, $sensor, $experiment, $filename, $filepath, $filedate
			);
			db_commit();
		}
		
		db_close();
	}
?>

